import re
import requests
import ctypes
import os
import sys
import webbrowser
import threading
import pickle
from bs4 import BeautifulSoup
from PIL import Image
import io
from tendo import singleton
me = singleton.SingleInstance()	# 중복 실행 방지

def getGiftList(num):
	global gift
	url = 'https://www.steamgifts.com/giveaways/search?page='
	header = {'User-agent': 'Mozilla/5.0'}	# 페이지를 가져올 때 해더가 없으면 403 오류 발생
	count = 1
	gift = [ ]
	for i in range(num):
		r = requests.get(url + str(count), headers=header)
		soup = BeautifulSoup(r.text, 'lxml')
		if soup.select('.pagination__results')[0].text == 'No results were found.':	# 끝까지 돌았으면 탈출
			count -= 1
			break
		# 게임 이름 추출
		name = [tag.text for tag in soup.select('.giveaway__row-inner-wrap .giveaway__heading__name')]
		# 기프트 링크 추출
		href = [tag.get('href') for tag in soup.select('.giveaway__row-inner-wrap .giveaway__heading__name')]
		# 기프트 카피수 추출
		copie = [ ]
		for tag in soup.select('.giveaway__row-inner-wrap .giveaway__heading'):
			tmp = re.search('\d.+(?= Copies)', tag.text)
			if tmp:
				copie.append(tmp.group())
			else:
				copie.append(None)
		# 남은 시간 추출
		time = [ ]
		for tag in soup.select('.giveaway__row-inner-wrap .giveaway__columns'):
			tmp = re.search('\d.+(?= remaining)', tag.text)
			if tmp:
				time.append(tmp.group())
			else:
				time.append(None)
		# 게임 이미지 추출
		image = [ ]
		for tag in soup.select('.giveaway__row-inner-wrap .global__image-inner-wrap'):
			image.append(re.search('http.+(?=[)];)', tag.get('style')).group())
		del image[::2]

		gift += list(zip(name, href, copie, time, image))	# 리스트로 묶기
		gift = list(set(gift))	# 중복 목록 제거
		count += 1
	gift.sort()	# 목록 정렬

def messageBox(title, text, style):
	return ctypes.windll.user32.MessageBoxW(None, text, title, style)
"""
style
0: 확인(1)
1: 확인(1), 취소(2)
2: 중단(3), 다시시도(4), 무시(5)
3: 예(6), 아니오(7), 취소(2)
4: 예(6), 아니오(7)
5: 다시시도(4), 취소(2)
6: 취소(2), 다시시도(10), 계속(11)
"""

def save():
	global search
	global history
	with open(os.environ['USERPROFILE'] + '\\search', 'wb') as f:	# 검색어 목록 파일. search
		pickle.dump(search, f)
	with open(os.environ['USERPROFILE'] + '\\history', 'wb') as f:	# 기프트 내역 파일. history
		pickle.dump(history, f)

def urlImgShow(url):	# 프롬프트 창에서는 이미지 출력 불가능
	r = requests.get(url)
	return Image.open(io.BytesIO(r.content))

os.system('cls')
try:	# 검색어 목록 파일. search
	with open(os.environ['USERPROFILE'] + '\\search', 'rb') as f:
		search = pickle.load(f)	# 검색어 목록 읽기
except:
	with open(os.environ['USERPROFILE'] + '\\search', 'wb') as f:	# 목록이 없으면 생성
		search = set()
		pickle.dump(search, f)
try:	# 기프트 내역 파일. history
	with open(os.environ['USERPROFILE'] + '\\history', 'rb') as f:
		history = pickle.load(f)	# 기프트 내역 읽기
except:
	with open(os.environ['USERPROFILE'] + '\\history', 'wb') as f:	# 내역이 없으면 생성
		history = [ ]
		pickle.dump(history, f)

# python sys1.py aaa bbb ccc
if len(sys.argv) > 1 and sys.argv[1] == 'auto':	# 작업 스케줄러에 의해 실행 시
	getGiftList(20)
	for find in search:
		for name in gift:
			if name[0].lower().find(find.lower()) != -1:
				try:	# 이미 기프트한 목록은 제외
					for url in history:
						if name[1] == url:
							raise
					menu = messageBox('SteamGifts 알리미', name[0] + ' 발견!!\n기프트 페이지를 여시겠습니까?\n취소를 누르면 다음에 다시 알립니다.', 3)
					if menu == 6:	# 예
						webbrowser.open('https://www.steamgifts.com' + name[1])
						history.append(name[1])
					elif menu == 7:	# 아니오
						history.append(name[1])
				except:
					pass
	if len(history) > 100:	# 내역이 100개 넘게 쌓이면
		history[:len(history) - 100] = [ ]	# 내역 정리
	save()
	sys.exit(0)

t = threading.Thread(target=getGiftList, args=(5,))	# 스레드 생성
t.daemon = True
t.start()

while True:
	os.system('cls')
	print()
	print(' ' * 8 + '┌' + '─' * 30 + '┐')
	print(' ' * 8 + '│┌─────────────┐┌─────────────┐│')
	print(' ' * 8 + '││ 1) 알림받을 게임 관리    ││ 2)  자동 알림 on/off     ││')
	print(' ' * 8 + '│└─────────────┘└─────────────┘│')
	print(' ' * 8 + '│┌─────────────┐┌─────────────┐│')
	print(' ' * 8 + '││ 3)  기프트 목록 보기     ││ X)        종료           ││')
	print(' ' * 8 + '│└─────────────┘└─────────────┘│')
	print(' ' * 8 + '└' + '─' * 30 + '┘')
	menu = input('\n원하는 메뉴을 선택해주세요. : ')
	if menu == 'x' or menu == 'X':	# 종료
		sys.exit(0)

	elif menu == '1':	# 알림받을 게임 관리
		while True:
			os.system('cls')
			print()
			print(' ' * 8 + '┌' + '─' * 30 + '┐')
			tmp = list(search)
			tmp.sort()
			for find in tmp:
				print(' ' * 8 + '│' + '%-60s' % find + '│')
			print(' ' * 8 + '└' + '─' * 30 + '┘')
			print('이 검색어 목록에 검색되는 기프트가 발견되면 사용자에게 알립니다.')
			print('\n A: 검색어 추가, D: 검색어 삭제, B: 뒤로가기')
			menu = input('원하는 메뉴를 입력하세요. : ')
			if menu == 'b' or menu == 'B':	# 뒤로가기
				break
			elif menu == 'a' or menu == 'A':	# 검색어 추가
				menu = input('\n추가할 검색어를 입력하세요. : ')
				search.add(menu.strip().lower())
				save()
			elif menu == 'd' or menu == 'D':	# 검색어 삭제
				menu = input('\n삭제할 검색어를 입력하세요. : ')
				try:
					search.remove(menu.strip().lower())
				except:
					pass
				save()

	elif menu == '2':	# 자동 알림 on/off
		while True:
			print('\n C: 자동알림 켜기, D: 자동알림 끄기, B: 뒤로가기')
			menu = input('원하는 메뉴를 입력하세요. : ')
			if menu == 'b' or menu == 'B':	# 뒤로가기
				break
			elif menu == 'c' or menu == 'C':	# 자동알림 켜기
				os.system('schtasks /create /sc MINUTE /mo 30 /tn SteamGifts /f /tr "cmd /c start pythonw '+ sys.argv[0] + ' auto"')
				break
			elif menu == 'd' or menu == 'D':	# 자동알림 끄기
				os.system('schtasks /delete /tn SteamGifts /f')
				break

	elif menu == '3':	# 기프트 목록 보기
		while True:
			os.system('cls')
			print()
			print(' ' * 8 + '┌' + '─' * 2 + '┬' + '─' * 21 + '┬' + '─' * 5 + '┐')
			print(' ' * 8 + '│' + '{0:^2}'.format('번호') + '│' + '{0:^38}'.format('게임 이름') + '│' + '{0:^6}'.format('남은 시간') + '│')
			print(' ' * 8 + '├' + '─' * 2 + '┴' + '─' * 21 + '┴' + '─' * 5 + '┤')
			for name in gift:
				try:
					print(' ' * 8 + '│' + '%4d' % (gift.index(name) + 1) + '  ' + '%-44s' % name[0] + '%10s' % name[3] + '│')
				except:
					pass
			print(' ' * 8 + '└' + '─' * 30 + '┘')
			print('\n F: 검색어 목록에 검색된 기프트 목록, B: 뒤로가기')
			menu = input('기프트 링크를 열고싶은 게임의 번호나 원하는 메뉴를 입력하세요. : ')
			if menu == 'b' or menu == 'B':	# 뒤로가기
				break
			elif menu == 'f' or menu == 'F':	# 검색어 목록에 검색된 기프트 목록
				os.system('cls')
				print()
				print(' ' * 8 + '┌' + '─' * 2 + '┬' + '─' * 21 + '┬' + '─' * 5 + '┐')
				print(' ' * 8 + '│' + '{0:^2}'.format('번호') + '│' + '{0:^38}'.format('게임 이름') + '│' + '{0:^6}'.format('남은 시간') + '│')
				print(' ' * 8 + '├' + '─' * 2 + '┴' + '─' * 21 + '┴' + '─' * 5 + '┤')
				for find in search:
					for name in gift:
						if name[0].lower().find(find.lower()) != -1:
							try:	# 이미 기프트한 목록은 제외
								for url in history:
									if name[1] == url:
										raise
								print(' ' * 8 + '│' + '%4d' % (gift.index(name) + 1) + '  ' + '%-44s' % name[0] + '%10s' % name[3] + '│')
							except:
								pass
				print(' ' * 8 + '└' + '─' * 30 + '┘')
				os.system('pause')
			else:	# 게임의 번호
				try:
					if int(menu) - 1 < 0:
						raise
					webbrowser.open('https://www.steamgifts.com' + gift[int(menu) - 1][1])
					history.append(gift[int(menu) - 1][1])
					if len(history) > 100:	# 내역이 100개 넘게 쌓이면
						history[:len(history) - 100] = [ ]	# 내역 정리
					save()
				except:
					print('올바른 번호를 입력해주세요.')
					os.system('pause > nul')
